package common;


public class TransferService {

    private BankService bankService;

    public TransferService(BankService bankService) {
        this.bankService = bankService;
    }

    public void transfer(Money money, String fromAccount, String toAccount) {

        // konverteeri summa krediteeritava konto valuutassse
        // ja krediteeri

        String fromCurrency = bankService.getAccountCurrency(fromAccount);
        Money creditAmountConverted = bankService.convert(money, fromCurrency);

        if (!bankService.hasSufficientFundsFor(creditAmountConverted))
            return;

        bankService.credit(creditAmountConverted, fromAccount);

        // konverteeri summa debiteeritava konto valuutassse
        // ja debiteeri

        String toCurrency = bankService.getAccountCurrency(toAccount);
        Money debitAmountConverted = bankService.convert(money, toCurrency);
        bankService.debit(debitAmountConverted, toAccount);
    }
}